///home/berryj/link/bin/genMethods "-g" "-t" "MSet<int>" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Set.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef MSet<int> _MSet_int_;
typedef Collection<MSet<int> > _Collection_MSet_int__;

#define _Collection_MSet_int__DATA(x) ((Collection<MSet<int> >*) (EXTDATA(x)))
#define _Collection_MSet_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<MSet<int> > >::type))
#define _Collection_MSet_int__ISNT_DATA(x) (!_Collection_MSet_int__IS_DATA(x))

#define _Collection_MSet_int__CXX_DATA(x) (*(Collection<MSet<int> >*) (EXTDATA(VAL(x))))
#define _Collection_MSet_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<MSet<int> > >::type))
#define _Collection_MSet_int__CXX_ISNT_DATA(x) (!_Collection_MSet_int__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_MSet_int__()
{
	Wrapper<_Collection_MSet_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_MSet_int__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_MSet_int_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_MSet_int_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_MSet_int_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_MSet_int__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_MSet_int__Methods(void);

PRIMITIVE STk_init_methods__Collection_MSet_int__()
{
	STk_add_new_cpp_primitive("collection-MSet-int?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collectionP);
	STk_add_new_cpp_primitive("mset-MSet-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::buildMSet);
	STk_add_new_cpp_primitive("set-MSet-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::buildSet);
	STk_add_new_cpp_primitive("sequence-MSet-int1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-MSet-int-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-MSet-int-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-MSet-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-MSet-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-MSet-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-MSet-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkList);
	STk_add_new_cpp_primitive("set-MSet-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-MSet-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-MSet-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkString);
	STk_add_new_cpp_primitive("set-MSet-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-MSet-int->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_MSet_int_>::collection2STkString);

	addListMethod("mset-MSet-int",
		"mset-MSet-int1", LINK_NEW);
	addListMethod("set-MSet-int",
		"set-MSet-int1", LINK_NEW);
	addListMethod("sequence-MSet-int",
		"sequence-MSet-int1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_MSet_int__ >::name, 
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_MSet_int_ >::name, 
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_MSet_int__ >::name, 
		"<integer>",
		"Collection-MSet-int-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_MSet_int_ >::name, 
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_MSet_int_ >::name, 
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_MSet_int_ >::name, 
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_MSet_int__ >::name, 
		"Collection-MSet-int--", LINK_OVL);
	genExtra_Collection_MSet_int__Methods();
	return UNDEFINED;
}
